
/*
Copyright 2007 Kim A. Brandt <kimabrandt@gmx.de>

This file is part of prefswitch.

Prefswitch is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Prefswitch is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with prefswitch; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

function Observer(control, type, prefRoot, preference, statusbarpanel)
{
	this.control        = control;
	this.type           = type;
	this.prefRoot       = prefRoot;
	this.preference     = preference;
	this.statusbarpanel = statusbarpanel;
	this.observable     = null;

// -----------------------------------------------------------------------------

	this.register = function()
	{
		if (this.prefRoot == null)   this.prefRoot   = this.control.ROOT;
		if (this.preference == null) this.preference = this.control.REFRESH;
		this.observable = this.control.prefService.getBranch(this.prefRoot);
//		this.observable.QueryInterface(Components.interfaces.nsIPrefBranchInternal); // < Gecko 1.8
		this.observable.QueryInterface(Components.interfaces.nsIPrefBranch2);        // >= Gecko 1.8
		this.observable.addObserver("", this, false);
	};

	this.unregister = function()
	{
		if (this.observable) this.observable.removeObserver("", this);
	};

	this.observe = function(aSubject, aTopic, aData)
	{
		if (aTopic != "nsPref:changed") return;
		if (aData == this.preference)   this.control.update(this.type, this.statusbarpanel);
	};
}
